/**
 * @(#)TextFileReader.java 1.1 20/01/2005
 * Copyright 2005 usd.sie.dendai.ac.jp, All rights reserved.
 */
package jp.tdu.util;

import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * TextFileReaderNX̓t@Cs̕ǂݎNXłB
 * s̋؂́AAAsAA^s̑gݍ킹A܂EOF(t@C̏I)Ԃŕ\܂B
 * @version 1.0, 20/01/2005
 * @author miya@sie.dendai.ac.jp
 */
public final class TextFileReader{
	private String filename;
	private FileInputStream fileInputStream;
	private BufferedReader  bufferdReader;
	
	/**
	 * B̃RXgN^łB
	 * @param name ǂݍ݌̃t@C̖Ow肵܂B
	 */
	public TextFileReader(String name){
		this.filename = name;
	}
	
	/**
	 * t@CJ܂B
	 * @return t@CJĂtrueAȊOłfalseԂ܂B
	 */
	public boolean open(){
		try{
			this.fileInputStream = new FileInputStream(this.filename);
			this.bufferdReader = new BufferedReader(new InputStreamReader(this.fileInputStream));
		}catch(IOException e){
			this.bufferdReader = null;
		}
		return this.ready();
	}
	
	/**
	 * t@C܂B
	 */
	public void close(){
		try{
			this.fileInputStream.close();         
		}catch(IOException e){
			this.bufferdReader = null;
		}
	}
	
	/**
	 * t@Cs̕ǂݎ܂B
	 * @return ǂݍ񂾕Ԃ܂B
	 */
	public String readLine(){
		String line = null;
		try{
			if(this.ready()){
				line = this.bufferdReader.readLine();
			}
		}catch(IOException e){
			this.bufferdReader = null;
		}
		return line;
	}
	
	/**
	 * t@ĆA1s̕RXgN^̈ƂTokensCX^X𐶐Aԋp܂B
	 * @return TokensCX^XԂ܂B
	 */
	public Tokens createTokens(){
		String line = null;
		try{
			if(this.ready()){
				line = this.bufferdReader.readLine();
			}
		}catch(IOException e){
			this.bufferdReader = null;
		}
		return new Tokens(line);
	}
	
	/**
	 * t@C當񂪓ǂݎ邩f܂B
	 * @return t@C̓̕ǂݎ肪\łtrueAȊOłfalseԂ܂B
	 */
	public boolean ready(){
		if(this.bufferdReader == null){
		  return false;
		}
		try{
			return this.bufferdReader.ready();
		}catch(IOException e){
			return false;
		}
	}
}
